﻿using System;
using System.Collections.Generic;
using System.Drawing;

namespace CBNA_Defender
{
    public class Monstre
    {
        public int Type;
        public bool Alive = true;
        public Image Sprite;
        public PointF Position;
        public float Vie;
        public Int16 Degat;
        public Rectangle Mask;
        public Rectangle MaskAnim;
        public Point Size;
        public PointF Vitesse;
        public Rectangle Border;//bordure à enlever(gauche,haut,hauteur,largeur)
        public float Anim = 0, AnimSpeed;
        public Int16 AnimEnd;
        public Int16 AnimDeadEnd;
        public Monstre()
        {

        }
        public static void Update()
        {
            for (int i = 0; i < Ressources.ListMonstre.Count; i++)
                if (Ressources.ListMonstre[i].Alive)
                {
                    Ressources.ListMonstre[i].Position.X += Ressources.ListMonstre[i].Vitesse.X;
                    Ressources.ListMonstre[i].Position.Y += Ressources.ListMonstre[i].Vitesse.Y;
                    Ressources.ListMonstre[i].Mask = new Rectangle((int)Ressources.ListMonstre[i].Position.X + Ressources.ListMonstre[i].Border.X, (int)Ressources.ListMonstre[i].Position.Y + Ressources.ListMonstre[i].Border.Y, Ressources.ListMonstre[i].Border.Width, Ressources.ListMonstre[i].Border.Height);
                    Ressources.ListMonstre[i].MaskAnim = new Rectangle((int)Ressources.ListMonstre[i].Anim * (int)Ressources.ListMonstre[i].Size.X, 0, (int)Ressources.ListMonstre[i].Size.X, (int)Ressources.ListMonstre[i].Size.Y);
                    Ressources.ListMonstre[i].Anim += Ressources.ListMonstre[i].AnimSpeed;
                    if (Ressources.ListMonstre[i].Vie > 0)
                    {
                        if (Ressources.ListMonstre[i].Anim > Ressources.ListMonstre[i].AnimEnd)
                            Ressources.ListMonstre[i].Anim = 0;
                    }
                    else
                        if (Ressources.ListMonstre[i].Anim > Ressources.ListMonstre[i].AnimDeadEnd)
                            Ressources.ListMonstre[i].Destroy();
                    if (Ressources.ListMonstre[i].Position.X >= 432 && Ressources.ListMonstre[i].Position.X <= 572 && Ressources.ListMonstre[i].Position.Y >= 612 && Ressources.ListMonstre[i].Vie > 0)
                    {
                        Form1.Vie -= Ressources.ListMonstre[i].Degat;
                        if (Ressources.ListMonstre[i].Vie <= 0)
                            Ressources.ListMonstre[i].Vie = 0;
                        Ressources.ListMonstre[i].Alive = false;
                    }
                    foreach (Balle Balle in Ressources.ListBalle)
                        if (Balle.Alive && Ressources.ListMonstre[i].Alive)
                            if (Ressources.ListMonstre[i].Mask.IntersectsWith(Balle.Mask))
                            {
                                Ressources.ListMonstre[i].Vie -= Balle.Degat;
                                Balle.Resistance--;
                                if (Balle.Resistance <= 0)
                                    Balle.Alive = false;
                            }
                    foreach (Tower Tower in Ressources.ListTower)
                        if (Tower.Alive && Ressources.ListMonstre[i].Alive)
                            if (Ressources.ListMonstre[i].Mask.IntersectsWith(Tower.Mask))
                            {
                                Ressources.ListMonstre[i].Vie -= Tower.Degat;
                                if (Ressources.ListMonstre[i].Vie <= 0)
                                    Ressources.ListMonstre[i].Destroy();
                                Tower.Stats[0] -= Ressources.ListMonstre[i].Degat;
                                if (Tower.Stats[0] <= 0)
                                    Tower.Dead();
                            }
                }
        }
        private void Destroy()
        {
            Alive = false;
            switch (Type)
            {
                case 0:
                    {
                        Form1.Argent += 20 + Form1.MonstreLife[Type] * 2;
                        Form1.Exp += 10 + Form1.MonstreLife[Type];
                        break;
                    }
                case 1:
                    {
                        Form1.Argent += 30 + Form1.MonstreLife[Type] * 2;
                        Form1.Exp += 20 + Form1.MonstreLife[Type];
                        break;
                    }
                case 2:
                    {
                        Form1.Argent += 10 + Form1.MonstreLife[Type] * 2;
                        Form1.Exp += 5 + Form1.MonstreLife[Type];
                        Form1.PartCreate(false, Position, new PointF(0, -3), new PointF(0, 0), Ressources.SprParticules[0], 0.3f, 3, 100, new Point(33, 53), 0);
                        break;
                    }
            }
        }
    }
}