﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CBNA_Defender
{
    public partial class frmMenu : Form
    {
        string Nom;
        public frmMenu()
        {
            InitializeComponent();
        }

        bool LireJoueur()
        {
            try
            {
                Nom = txtJoueur.Text;
            }
            catch
            {
                MessageBox.Show("Nom invalide");
                txtJoueur.Focus();
                return false;
            }
            if (Nom != "")
                return true;
            MessageBox.Show("Nom invalide");
            txtJoueur.Focus();
            return false;
        }

        private void btnNoob_Click(object sender, EventArgs e)
        {
            StreamReader Fichier = new StreamReader("Aide.txt", Encoding.Default);
            string Message = Fichier.ReadToEnd();
            MessageBox.Show(Message);
            Fichier.Dispose();
        }

        private void btnEnrg_Click(object sender, EventArgs e)
        {
            if (!LireJoueur())
                return;
            StreamWriter f = new StreamWriter("stat.txt", true);
            f.WriteLine(Nom);
            f.WriteLine(Form1.Argent);
            f.Close();
        }

        private void btnStat_Click(object sender, EventArgs e)
        {
            if (!File.Exists("stat.txt"))
            {
                MessageBox.Show("Aucun joueurs enregistré");
                return;
            }
            StreamReader Fichier = new StreamReader("stat.txt");
            string Message = Fichier.ReadToEnd();
            MessageBox.Show(Message);
            Fichier.Dispose();
        }

        private void btnQuitter_Click(object sender, EventArgs e)
        {
            Form1.Fermer = true;
            this.Close();
        }

        private void btnSauve_Click(object sender, EventArgs e)
        {
            if (!LireJoueur())
                return;
            SaveFileDialog Fichier = new SaveFileDialog();
            Fichier.Filter = "Fichier sauvegarde (.cbna)| *.cbna";
            Fichier.ShowDialog();
            if (Fichier.FileName == "")
                return;
            FileStream FS = new FileStream(Fichier.FileName, FileMode.Create, FileAccess.Write);
            StreamWriter SW = new StreamWriter(FS);
            SW.WriteLine(Nom);
            SW.WriteLine(Form1.Argent);
            SW.WriteLine(Form1.Energie);
            SW.WriteLine(Form1.MaxEnergie);
            SW.WriteLine(Form1.Wave);
            SW.WriteLine(Form1.Vie);
            SW.WriteLine(Ressources.ListTower.Count);
            foreach (Tower Tower in Ressources.ListTower)
            {
                SW.WriteLine(Tower.Type);
                SW.WriteLine(Tower.Alive);
                SW.WriteLine(Tower.Effects);
                for (int i = 0; i < 6; i++)
                    SW.WriteLine(Tower.Stats[i]);
                SW.WriteLine(Tower.Position.X.ToString());
                SW.WriteLine(Tower.Position.Y.ToString());
            }
            SW.WriteLine(Ressources.ListMonstre.Count);
            foreach (Monstre Monstre in Ressources.ListMonstre)
            {
                SW.WriteLine(Monstre.Type);
                SW.WriteLine(Monstre.Vie);
                SW.WriteLine(Monstre.Alive);
                SW.WriteLine(Monstre.Vitesse.X);
                SW.WriteLine(Monstre.Position.X);
                SW.WriteLine(Monstre.Position.Y);
            }
            SW.Close();
            FS.Close();
        }

        private void btnCharge_Click(object sender, EventArgs e)
        {
            OpenFileDialog Fichier = new OpenFileDialog();
            Fichier.Filter = "Fichier sauvegarde|*.cbna";
            Fichier.ShowDialog();
            if (Fichier.FileName == "")
                return;
            FileStream FS = new FileStream(Fichier.FileName, FileMode.Open, FileAccess.Read);
            StreamReader SR = new StreamReader(FS);
            Nom = SR.ReadLine();
            Form1.Argent = Convert.ToInt32(SR.ReadLine());
            Form1.Energie = Convert.ToSingle(SR.ReadLine());
            Form1.MaxEnergie = Convert.ToInt16(SR.ReadLine());
            Form1.Wave = Convert.ToByte(SR.ReadLine());
            Form1.Vie = Convert.ToInt16(SR.ReadLine());
            int bob = Convert.ToInt32(SR.ReadLine());
            Ressources.ListTower.Clear();
            #region Création de tour
            for (int i = 0; i < bob; i++)
            {
                Tower Tower = new Tower();
                Tower.Type = Convert.ToInt32(SR.ReadLine());
                Tower.Alive = Convert.ToBoolean(SR.ReadLine());
                Tower.Effects = Convert.ToBoolean(SR.ReadLine());
                for (int j = 0; j < 6; j++)
                    Tower.Stats[j] = Convert.ToSingle(SR.ReadLine());
                Tower.Position.X = Convert.ToSingle(SR.ReadLine());
                Tower.Position.Y = Convert.ToSingle(SR.ReadLine());

                switch (Tower.Type)
                {
                    case 0:
                        {
                            Tower.Nom = "Bunker";
                            Tower.Border = new Rectangle(0, 0, 0, 0);//bordure à enlever(gauche,haut,hauteur,largeur)
                            Tower.AnimSpeed = 0;
                            Tower.AnimEnd = 0;
                            Tower.AnimDeadEnd = 0;
                            Tower.Size = new Point(30, 30);
                            Tower.Sprite = Ressources.SprTower[0, 0, Convert.ToInt16(Tower.Effects)];
                            Tower.Mask = new Rectangle((int)Tower.Position.X, (int)Tower.Position.Y, Tower.Size.X, Tower.Size.Y);
                            Tower.MaskAnim = new Rectangle(0, 0, (int)Tower.Size.X, (int)Tower.Size.Y);
                            Tower.Degat = 0;
                            Tower.ArmePriceBase = 200;
                            Tower.ArmePriceModifier = 250;
                            Tower.PriceBase[0] = 100;
                            Tower.PriceBase[1] = 100;
                            Tower.PriceBase[2] = 100;
                            Tower.PriceBase[3] = 100;
                            Tower.PriceBase[4] = 100;
                            Tower.PriceBase[5] = 100;
                            Tower.PriceModifier[0] = 100;
                            Tower.PriceModifier[1] = 100;
                            Tower.PriceModifier[2] = 100;
                            Tower.PriceModifier[3] = 100;
                            Tower.PriceModifier[4] = 100;
                            Tower.PriceModifier[5] = 100;
                            Tower.Niveau = new Int16[6] { 1, 1, 1, 1, 1, 1 };
                            Tower.StatsModifier[0] = 2;
                            Tower.StatsModifier[1] = -2.5f;
                            Tower.StatsModifier[2] = -0.2f;
                            Tower.StatsModifier[3] = 1;
                            Tower.StatsModifier[4] = 1.5f;
                            Tower.StatsModifier[5] = 1;
                            break;
                        }
                    case 1:
                        {
                            Tower.Nom = "Arbre d'attaque";
                            Tower.Border = new Rectangle(0, 0, 0, 0);//bordure à enlever(gauche,haut,hauteur,largeur)
                            Tower.AnimSpeed = 0;
                            Tower.AnimEnd = 0;
                            Tower.AnimDeadEnd = 0;
                            Tower.Size = new Point(30, 30);
                            Tower.Sprite = Ressources.SprTower[0, 1, Convert.ToInt16(Tower.Effects)];
                            Tower.Mask = new Rectangle((int)Tower.Position.X, (int)Tower.Position.Y, Tower.Size.X, Tower.Size.Y);
                            Tower.MaskAnim = new Rectangle(0, 0, (int)Tower.Size.X, (int)Tower.Size.Y);
                            Tower.Degat = 0;
                            Tower.ArmePriceBase = 200;
                            Tower.ArmePriceModifier = 250;
                            Tower.PriceBase[0] = 100;
                            Tower.PriceBase[1] = 100;
                            Tower.PriceBase[2] = 100;
                            Tower.PriceBase[3] = 100;
                            Tower.PriceBase[4] = 100;
                            Tower.PriceBase[5] = 100;
                            Tower.PriceModifier[0] = 100;
                            Tower.PriceModifier[1] = 100;
                            Tower.PriceModifier[2] = 100;
                            Tower.PriceModifier[3] = 100;
                            Tower.PriceModifier[4] = 100;
                            Tower.PriceModifier[5] = 100;
                            Tower.Niveau = new Int16[6] { 1, 1, 1, 1, 1, 1 };
                            Tower.StatsModifier[0] = 1;
                            Tower.StatsModifier[1] = -2;
                            Tower.StatsModifier[2] = -0.2f;
                            Tower.StatsModifier[3] = 0.75f;
                            Tower.StatsModifier[4] = 1;
                            Tower.StatsModifier[5] = 1;
                            break;
                        }
                    case 2:
                        {
                            Tower.Nom = "Roue humaine";
                            Tower.Border = new Rectangle(0, 0, 0, 0);//bordure à enlever(gauche,haut,hauteur,largeur)
                            Tower.AnimSpeed = 0;
                            Tower.AnimEnd = 0;
                            Tower.AnimDeadEnd = 0;
                            Tower.Size = new Point(60, 60);
                            Tower.Sprite = Ressources.SprTower[2, 0, Convert.ToInt16(Tower.Effects)];
                            Tower.Mask = new Rectangle((int)Tower.Position.X, (int)Tower.Position.Y, Tower.Size.X, Tower.Size.Y);
                            Tower.MaskAnim = new Rectangle(0, 0, (int)Tower.Size.X, (int)Tower.Size.Y);
                            Tower.Degat = 1;
                            Tower.ArmePriceBase = 200;
                            Tower.ArmePriceModifier = 150;
                            Tower.PriceBase[0] = 75;
                            Tower.PriceBase[1] = 0;
                            Tower.PriceBase[2] = 150;
                            Tower.PriceBase[3] = 0;
                            Tower.PriceBase[4] = 0;
                            Tower.PriceBase[5] = 0;
                            Tower.PriceModifier[0] = 100;
                            Tower.PriceModifier[1] = -1;
                            Tower.PriceModifier[2] = 125;
                            Tower.PriceModifier[3] = -1;
                            Tower.PriceModifier[4] = -1;
                            Tower.PriceModifier[5] = -1;
                            Tower.Niveau = new Int16[6] { 1, 1, 1, 1, 1, 1 };
                            Tower.StatsModifier[0] = 1;
                            Tower.StatsModifier[1] = 0;
                            Tower.StatsModifier[2] = -0.15f;
                            Tower.StatsModifier[3] = 0;
                            Tower.StatsModifier[4] = 0;
                            Tower.StatsModifier[5] = 0;
                            break;
                        }
                    case 3:
                        {
                            Tower.Nom = "Echafaud";
                            Tower.Border = new Rectangle(0, 0, 0, 0);//bordure à enlever(gauche,haut,hauteur,largeur)
                            Tower.AnimSpeed = 0;
                            Tower.AnimEnd = 0;
                            Tower.AnimDeadEnd = 0;
                            Tower.Size = new Point(30, 30);
                            Tower.Sprite = Ressources.SprTower[2, 1, Convert.ToInt16(Tower.Effects)];
                            Tower.Mask = new Rectangle((int)Tower.Position.X, (int)Tower.Position.Y, Tower.Size.X, Tower.Size.Y);
                            Tower.MaskAnim = new Rectangle(0, 0, (int)Tower.Size.X, (int)Tower.Size.Y);
                            Tower.Degat = 0;
                            Tower.ArmePriceBase = 0;
                            Tower.ArmePriceModifier = 0;
                            Tower.PriceBase[0] = 0;
                            Tower.PriceBase[1] = 0;
                            Tower.PriceBase[2] = 0;
                            Tower.PriceBase[3] = 0;
                            Tower.PriceBase[4] = 0;
                            Tower.PriceBase[5] = 0;
                            Tower.PriceModifier[0] = -1;
                            Tower.PriceModifier[1] = -1;
                            Tower.PriceModifier[2] = -1;
                            Tower.PriceModifier[3] = -1;
                            Tower.PriceModifier[4] = -1;
                            Tower.PriceModifier[5] = -1;
                            Tower.Niveau = new Int16[6] { 1, 1, 1, 1, 1, 1 };
                            Tower.StatsModifier[0] = 0;
                            Tower.StatsModifier[1] = 0;
                            Tower.StatsModifier[2] = 0;
                            Tower.StatsModifier[3] = 0;
                            Tower.StatsModifier[4] = 0;
                            Tower.StatsModifier[5] = 0;
                            break;
                        }
                }
                Ressources.ListTower.Add(Tower);
            }
            #endregion
            #region Cération de monstre
            bob = Convert.ToInt32(SR.ReadLine());
            Ressources.ListMonstre.Clear();
            for (int i = 0; i < bob; i++)
            {
                Monstre Monstre = new Monstre();
                Monstre.Type = Convert.ToInt32(SR.ReadLine());
                Monstre.Vie = Convert.ToSingle(SR.ReadLine());
                Monstre.Alive = Convert.ToBoolean(SR.ReadLine());
                Monstre.Vitesse = new PointF(Convert.ToSingle(SR.ReadLine()), 0);
                Monstre.Position.X = Convert.ToSingle(SR.ReadLine());
                Monstre.Position.Y = Convert.ToSingle(SR.ReadLine());
                Monstre.Sprite=Ressources.SprMonstre[Monstre.Type, Convert.ToInt16(Monstre.Vitesse.X<0)];
                switch (Monstre.Type)
                {
                    case 0:
                        {
                            Monstre.Degat = 1;
                            Monstre.Size = new Point(30, 30);
                            Monstre.Border = new Rectangle(0, 0, 30, 30);
                            Monstre.AnimSpeed = 0.2f;
                            Monstre.AnimEnd = 2;
                            Monstre.AnimDeadEnd = 6;
                            break;
                        }
                    case 1:
                        {
                            Monstre.Degat = 3;
                            Monstre.Size = new Point(88, 64);
                            Monstre.Border = new Rectangle(25, 4, 30, 60);
                            Monstre.AnimSpeed = 0.3f;
                            Monstre.AnimEnd = 3;
                            Monstre.AnimDeadEnd = 9;
                            break;
                        }
                    case 2:
                        {
                            Monstre.Degat = 1;
                            Monstre.Size = new Point(70, 60);
                            Monstre.Border = new Rectangle(32, 15, 30, 30);
                            Monstre.AnimSpeed = 0.2f;
                            Monstre.AnimEnd = 3;
                            Monstre.AnimDeadEnd = 8;
                            break;
                        }
                }
                Ressources.ListMonstre.Add(Monstre);
            }
            #endregion
            SR.Close();
            FS.Close();
            Form1.Wave--;
            Form1.WaveSelect();
        }
    }
}